--[[
	The corpses mod made by Mora_rus(#114940) and DatRat(#133832)
	Lua: Mora_rus
	Gfx: DatRat, Mora_rus
	Sfx: aha, there is no sfx!
]]

MOD={}
MOD.CORPSES={}
CORPSES=MOD.CORPSES
MOD.PLAYERS_V={}
PLAYERS_V=MOD.PLAYERS_V
MOD.BP={}
BP=MOD.BP

-- Changeable Settings

local total_living_time=30	-- in seconds. 5-120 seconds. Otherwise fixed
local total_fading_time=10	-- in seconds. This value should be always smaller than the previous one but not smaller than 1. Otherwise fixed
local blood_like_effect=true	-- is there should be a red trace with effect "flare" when bodyparts are flyin'?

local global_path="gfx/mora_datrat/crps" -- required to escape "/" at the last path due to pathing reasons, otherwise bugs.
-- "gfx/mora/" is not right. "gfx/mora" is right

MOD.WEAPONSPOWER={
	-- it used for bodyparts range and for corpses offset. Prefer to leave it like that
	-- pistols
	['1']=7,
	['2']=6,
	['3']=8,
	['4']=6,
	['5']=6,
	['6']=6,
	-- shotguns
	['10']=15,
	['11']=13,
	-- smgs
	['20']=7,
	['21']=6,
	['22']=7,
	['23']=6,
	['24']=7,
	-- rifles
	['30']=9,
	['31']=11,
	['32']=9,
	['33']=11,
	['34']=12,
	['35']=14,
	['36']=12,
	['37']=12,
	['38']=9,
	['39']=9,
	['91']=9,
	-- heavy
	['40']=10,
	['45']=15,
	['46']=7,
	['47']=15,
	['48']=13,
	['49']=13,
	['90']=10,
	-- melee
	['50']=3,
	['69']=7,
	['74']=3,
	['78']=4,
	['85']=6,
	-- grenades
	['51']=14,
	['72']=1,
	['73']=6,
	['75']=3,
	['76']=17,
	['86']=4,
	['89']=8,
	-- mines
	['77']=12,
	['87']=10,
	-- cs2dexplosion
	['251']=10,
	-- tileexplosion
	['241']=10
}
WEAPONSPOWER=MOD.WEAPONSPOWER

MOD.WEAPONSTABLE={
	-- types of bodyparts and wounds. Changis this requires to change the code below in spawn_corpse() function!!!
	["NOWOUNDS"]={78,86,254,255},
	["NORMAL"]={1,2,3,4,5,6,20,21,22,23,24,30,31,32,33,34,35,36,37,38,39,91,90,40,253,249},
	["PWN"]={10,11},
	["LASER"]={45},
	["FIRE"]={46,73},
	["WOUNDS"]={50,74},
	["DEEPWOUNDS"]={69,85},
	["EXPLOSIVES"]={47,48,49,51,76,77,87,89,251},
	["FREEZING"]={75},
	["SUFFOCATING"]={72}
}
WEAPONSTABLE=MOD.WEAPONSTABLE

-- End Changeable Settings

-- Settings

if total_living_time<=5 then
	total_living_time=6
elseif total_living_time>120 then
	total_living_time=120
end

if total_fading_time>=total_living_time then
	total_fading_time=math.ceil(total_living_time/2)
elseif total_fading_time<1 then
	total_fading_time=1
end

gamemode=tonumber(game("sv_gamemode"))

-- End settings

-- Hooks

addhook('team','MOD.team')
function MOD.team(id,team)
	MOD.player_check(id,team,true)
end

addhook('leave','MOD.leave')
function MOD.leave(id,reason)
	MOD.player_check(id,team,false)
end

addhook("hit","MOD.hit")
function MOD.hit(id,source,weapon,hpdmg,apdmg,rawdmg,objectid)
	MOD.hits_check(id,source,weapon,hpdmg,apdmg,rawdmg,objectid)
end

addhook("startround","MOD.startendround")
function MOD.startendround()
	MOD.startround_settings()
end

addhook("die","MOD.die")
function MOD.die(victim,killer,weapon,x,y,killid)
	MOD.dying_check(victim,killer,weapon,x,y,killid)
end

addhook("kill","MOD.kill")
function MOD.kill(source,victim,weapon,x,y,dynid)
	MOD.killing_check(source,victim,weapon,x,y,dynid)
end

addhook("ms100","MOD.ms100")
function MOD.ms100()
	MOD.bp_update()
end

addhook("second","MOD.second")
function MOD.second()
	MOD.corpses_check()
	MOD.bp_check()
end

-- End hooks

-- Functions

function MOD.total_check(source,id)
	local friendlyfire=tonumber(game("sv_friendlyfire"))
	if gamemode~=1 then
		if player(source,"team")==player(id,"team") then
			if friendlyfire==0 then
				return false
			end
		end
	end
	return true
end

function MOD.player_check(id,team,boolean)
	-- team hook
	if boolean then
		if not (type(PLAYERS_V[id])=="number") then
			PLAYERS_V[id]=0
		end
	else
		if (type(PLAYERS_V[id])=="number") then
			PLAYERS_V[id]=nil
		end
	end
end

function MOD.hits_check(id,source,weapon,hpdmg,apdmg,rawdmg,objectid)
	-- hit hook
	if MOD.total_check(source,id) then
		for k,v in pairs(WEAPONSTABLE["NORMAL"]) do
			if v==weapon then
				if PLAYERS_V[id]+1<6 then
					PLAYERS_V[id]=PLAYERS_V[id]+1
				end
			end
		end
	end
end

function MOD.startround_settings()
	-- startround hook
	for _,id in pairs(player(0,"table")) do
		if (type(PLAYERS_V[id])=="number") then
			PLAYERS_V[id]=0
		end
	end
	if #CORPSES~=0 then
		for k,v in pairs(CORPSES) do
			if v.img then
				freeimage(v.img)
			end
			if v.blood then
				freeimage(v.blood)
			end
		end
		CORPSES={}
	end
	if #BP~=0 then
		for k,v in pairs(BP) do
			for key,images in pairs(v) do
				freeimage(images[1])
			end
		end
		BP={}
	end
	gamemode=tonumber(game("sv_gamemode"))
end

function MOD.killing_check(source,victim,weapon,x,y,dynid)
	-- kill hook
	local sourceROT=player(source,"rot")
	local victimTEAM=player(victim,"team")
	local victimLOOK=player(victim,"look")
	local victimROT=player(victim,"rot")
	local tx=player(victim,"tilex")
	local ty=player(victim,"tiley")
	local distance=false
	local dist=math.sqrt(((player(source,"x")-player(victim,"x"))^2)+((player(source,"y")-player(victim,"y"))^2))
	if weapon==10 then
		local wdist=150
		if wdist/2>=dist then
			distance=true
		end
	elseif weapon==11 then
		local wdist=90
		if wdist/2>=dist then
			distance=true
		end
	end
	local modedeath
	if gamemode==0 then
		modedeath="inf"
	elseif gamemode==1 or gamemode==2 or gamemode==3 then
		modedeath=total_living_time
	elseif gamemode==4 then
		if victimTEAM==1 then
			modedeath=total_living_time
		else
			modedeath="inf"
		end
	end
	MOD.spawn_corpse(x,y,sourcex,sourcey,victimx,victimy,modedeath,weapon,sourceROT,victimTEAM,victimLOOK,victimROT,distance,PLAYERS_V[victim],tx,ty,source,victim)
end

function MOD.dying_check(victim,killer,weapon,x,y,killid)
	-- die hook
	if weapon==239 or weapon==254 or weapon==251 or weapon==248 or weapon==249 or weapon==253 or weapon==240 or weapon==241 or weapon==243 or weapon==255 then
		if killer==0 then
			local modedeath
			if gamemode==0 then
				modedeath="inf"
			elseif gamemode==1 or gamemode==2 or gamemode==3 then
				modedeath=total_living_time
			elseif gamemode==4 then
				if victimTEAM==1 then
					modedeath=total_living_time
				else
					modedeath="inf"
				end
			end
			local victimTEAM=player(victim,"team")
			local victimLOOK=player(victim,"look")
			local victimROT=player(victim,"rot")
			local tx=player(victim,"tilex")
			local ty=player(victim,"tiley")
			MOD.spawn_corpse(x,y,0,0,0,0,modedeath,weapon,0,victimTEAM,victimLOOK,victimROT,0,PLAYERS_V[victim],tx,ty,0,victim)
		end
	end
end

function MOD.corpses_check()
	-- second hook
	if #CORPSES~=0 then
		for k,v in pairs(CORPSES) do
			if not (type(v.modedeath)=="string") then
				if v.modedeath-1>0 then
					v.modedeath=v.modedeath-1
					if v.modedeath==total_fading_time then
						if v.img then
							tween_alpha(v.img,total_fading_time*1000,0.0)
						end
						if v.blood then
							tween_alpha(v.blood,total_fading_time*1000,0.0)
						end
					end
					if v.type=="fired" then
						if v.modedeath>total_fading_time/2 then
							parse("effect \"smoke\" " .. object(v.img,"x") .. " " .. object(v.img,"y") .. " 2 16")
						end
					elseif v.type=="freezed" then
						if v.modedeath>total_fading_time/2 then
							parse("effect \"colorsmoke\" " .. object(v.img,"x") .. " " .. object(v.img,"y") .. " 1 10 170 170 255")
						end
					elseif v.type=="suffocated" then
						if v.modedeath>total_fading_time/2 then
							parse("effect \"colorsmoke\" " .. v.hx .. " " .. v.hy .. " 1 4 0 125 0")
						end
					end
				else
					v.modedeath=0
					MOD.remove_corpse(k)
				end
			end
		end
	end
end

function MOD.bp_check()
	-- second hook
	if #BP~=0 then
		for k,v in pairs(BP) do
			for key,images in pairs(v) do
				if not (type(images[2])=="string") then
					if images[2]-1>0 then
						images[2]=images[2]-1
						if images[2]==total_fading_time then
							tween_alpha(images[1],total_fading_time*1000,0.0)
						end
					else
						images[2]=0
						MOD.remove_bp(k)
					end
				end
			end
		end
	end
end

function MOD.bp_update()
	-- ms100 hook
	if #BP~=0 then
		for k,v in pairs(BP) do
			for key,images in pairs(v) do
				if images[3]-1>0 then
				images[3]=images[3]-1
				images[7]=images[7]+20
					local ex = images[5] + math.cos(math.rad(images[4]-90))*images[3]
					local ey = images[6] + math.sin(math.rad(images[4]-90))*images[3]
					if blood_like_effect then
						parse("effect \"flare\" " .. ex .. " " .. ey .. " 1 1 25 0 0")
					end
					if (tile(math.floor(ex/32),math.floor(ey/32),"walkable")) then
						images[5]=ex
						images[6]=ey
						tween_move(images[1],99,images[5],images[6],images[7])
					else
						images[3]=math.random(2,5)
						images[4]=-images[4]
						local ex = images[5] + math.cos(math.rad(images[4]-90))*images[3]
						local ey = images[6] + math.sin(math.rad(images[4]-90))*images[3]
						if not (tile(math.floor(ex/32),math.floor(ey/32),"walkable")) then
							images[4]=images[4] + 180
							local eex = images[5] + math.cos(math.rad(images[4]-90))*images[3]
							local eey = images[6] + math.sin(math.rad(images[4]-90))*images[3]
							if not (tile(math.floor(eex/32),math.floor(eey/32),"walkable")) then
								images[3]=0
							end
						end
						ex = images[5] + math.cos(math.rad(images[4]-90))*images[3]
						ey = images[6] + math.sin(math.rad(images[4]-90))*images[3]
						images[5]=ex
						images[6]=ey
						tween_move(images[1],99,images[5],images[6],images[7])
					end
				end
			end
		end
	end
end

function MOD.convert_rot(rot)
	if (rot < 0) then
		rot=rot + 360
	end
	return rot
end

function MOD.spawn_corpse(x,y,sourcex,sourcey,victimx,victimy,modedeath,weapon,sourceROT,victimTEAM,victimLOOK,victimROT,distance,hits,tx,ty,source,victim)
	local killtype
	for k,v in pairs(WEAPONSTABLE) do
		for s,b in pairs(v) do
			if weapon==b then
				killtype=k
				break
			end
		end
	end
	local cside=1
	local corpsetype="s"	
	if MOD.convert_rot(victimROT)+50-45<=MOD.convert_rot(sourceROT)+50 and MOD.convert_rot(victimROT)+50+45>=MOD.convert_rot(sourceROT)+50 then
		corpsetype="b"
	elseif MOD.convert_rot(victimROT)-45<=MOD.convert_rot(sourceROT-180) and MOD.convert_rot(victimROT)+45>=MOD.convert_rot(sourceROT-180) then
		corpsetype="s"
	elseif MOD.convert_rot(victimROT)-45<=MOD.convert_rot(sourceROT-90) and MOD.convert_rot(victimROT)+45>=MOD.convert_rot(sourceROT-90) then
		corpsetype="v"
		cside=1
	elseif MOD.convert_rot(victimROT)-45<=MOD.convert_rot(sourceROT-270) and MOD.convert_rot(victimROT)+45>=MOD.convert_rot(sourceROT-270) then
		corpsetype="v"
		cside=-1
	end
	local img
	local blood
	local ex
	local ey
	local hx
	local hy
	local type
	if victimTEAM==3 then
		victimLOOK=1
	end
	if weapon==239 or weapon==254 or weapon==255 or weapon==253 or weapon==248 or weapon==249 or weapon==240 then
	local rtt={"s","b","v"}
	local rat=rtt[math.random(1,#rtt)]
		if gamemode==4 then
			if victimTEAM==2 then
				img=image(global_path..'/'..victimTEAM..victimLOOK..rat..'.png',x,y,0)
			else
				img=image(global_path..'/zm_'..rat..'.png',x,y,0)
			end
		else
			img=image(global_path..'/'..victimTEAM..victimLOOK..rat..'.png',x,y,0)
		end
		if weapon==248 then	
			blood=image(global_path..'/bld_sh'..hits..math.random(1,3)..'_'..rat..'.png',x,y,0)
		elseif weapon==249 then
			blood=image(global_path..'/bld_z_'..corpsetype..math.random(1,4)..'.png',x,y,0)
		elseif weapon==253 then
			blood=image(global_path..'/bld_sh'..hits..math.random(1,3)..'_'..rat..'.png',x,y,0)
		elseif weapon==255 then
			blood=image(global_path..'/bld_w_'..rat..'.png',x,y,0)
		end
		ex = x - math.cos(math.rad(victimROT-90))*2
		ey = y - math.sin(math.rad(victimROT-90))*2
		local rotin=-math.deg(math.atan2((x-ex),(y-ey)))
		if img then
			tween_rotate(img,0,rotin)
			imagescale(img,cside,1)	
			tween_move(img,300,ex,ey)
		end
		if blood then
			tween_move(blood,300,ex,ey)
			tween_rotate(blood,0,rotin)
			imagescale(blood,cside,1)
		end
	elseif weapon==251 then
		MOD.spawn_bp(x,y,WEAPONSPOWER[tostring(weapon)],victimTEAM,victimLOOK,modedeath,{"all"})
	elseif weapon==241 then
		MOD.spawn_bp(x,y,WEAPONSPOWER[tostring(weapon)],victimTEAM,victimLOOK,modedeath,{"all"})
	elseif weapon==243 then
		if gamemode==4 then
			if victimTEAM==2 then
				img=image(global_path..'/'..victimTEAM..victimLOOK..'f.png',x,y,0)
			else
				img=image(global_path..'/zm_f.png',x,y,0)
			end
		else
			img=image(global_path..'/'..victimTEAM..(victimLOOK or 1)..'f.png',x,y,0)
		end
		if img then
			tween_rotateconstantly(img,5)
			tween_scale(img,1000,0,0)
			tween_alpha(img,1000,0.0)
			tween_move(img,300,tx*32+16,ty*32+16)
			modedeath=2
		end
	else
		if killtype=="FIRE" then
			if gamemode==4 then
				if victimTEAM==2 then
					img=image(global_path..'/b_'..corpsetype..'.png',x,y,0)
				else
					img=image(global_path..'/zmb_'..corpsetype..'.png',x,y,0)
				end
			else
				img=image(global_path..'/b_'..corpsetype..'.png',x,y,0)
			end
			type="fired"
		elseif killtype=="FREEZING" then
			if gamemode==4 then
				if victimTEAM==2 then
					img=image(global_path..'/'..victimTEAM..victimLOOK..corpsetype..'.png',x,y,0)
				else
					img=image(global_path..'/zm_'..corpsetype..'.png',x,y,0)
				end
			else
				img=image(global_path..'/'..victimTEAM..victimLOOK..corpsetype..'.png',x,y,0)
			end
			imagecolor(img,100,100,255)
			tween_color(img,total_living_time*1000,255,255,255)
			type="freezed"
		elseif killtype=="EXPLOSIVES" then
			MOD.spawn_bp(x,y,WEAPONSPOWER[tostring(weapon)],victimTEAM,victimLOOK,modedeath,{"all"})
		else
			if gamemode==4 then
				if victimTEAM==2 then
					img=image(global_path..'/'..victimTEAM..victimLOOK..corpsetype..'.png',x,y,0)
				else
					img=image(global_path..'/zm_'..corpsetype..'.png',x,y,0)
				end
			else
				img=image(global_path..'/'..victimTEAM..victimLOOK..corpsetype..'.png',x,y,0)
			end
			if killtype=="NORMAL" then
				blood=image(global_path..'/bld_sh'..hits..math.random(1,3)..'_'..corpsetype..'.png',x,y,0)
			elseif killtype=="PWN" then
				if distance then
					blood=image(global_path..'/bld_sht2_'..corpsetype..'.png',x,y,0)
				else
					blood=image(global_path..'/bld_sht1_'..corpsetype..'.png',x,y,0)
				end
			elseif killtype=="WOUNDS" then
				blood=image(global_path..'/bld_w_'..corpsetype..'.png',x,y,0)
			elseif killtype=="SUFFOCATING" then
				if corpsetype~="b" then
					blood=image(global_path..'/gas_w_'..corpsetype..'.png',x,y,0)
				end
				type="suffocated"
			elseif killtype=="DEEPWOUNDS" then
				blood=image(global_path..'/bld_dw_'..corpsetype..'.png',x,y,0)
			elseif killtype=="LASER" then
				blood=image(global_path..'/bld_l_'..corpsetype..'.png',x,y,0)
			elseif killtype=="NOWOUNDS" then
				if weapon==78 then
					if gamemode==4 then
						blood=image(global_path..'/bld_z_'..corpsetype..math.random(1,4)..'.png',x,y,0)
					end
				end
			end
		end
		ex = x + math.cos(math.rad(sourceROT-90))*(15+WEAPONSPOWER[tostring(weapon)])
		ey = y + math.sin(math.rad(sourceROT-90))*(15+WEAPONSPOWER[tostring(weapon)])
		if corpsetype~="b" then
			hx = x + math.cos(math.rad(sourceROT-90))*(35+WEAPONSPOWER[tostring(weapon)])
			hy = y + math.sin(math.rad(sourceROT-90))*(35+WEAPONSPOWER[tostring(weapon)])
		else
			hx = x + math.cos(math.rad(sourceROT-90))*(37+WEAPONSPOWER[tostring(weapon)])
			hy = y + math.sin(math.rad(sourceROT-90))*(37+WEAPONSPOWER[tostring(weapon)])
		end
		
		if img then
			tween_rotate(img,0,sourceROT)
			imagescale(img,cside,1)	
			tween_move(img,300,ex,ey)
		end
		
		if blood then
			tween_move(blood,300,ex,ey)
			tween_rotate(blood,0,sourceROT)
			imagescale(blood,cside,1)
		end
	end
	if img then
		if blood then
			table.insert(CORPSES, {img=img, modedeath=modedeath, blood=blood, type=type or nil, hx=hx or nil, hy=hy or nil})
		else
			table.insert(CORPSES, {img=img, modedeath=modedeath, type=type or nil, hx=hx or nil, hy=hy or nil})
		end
	else
		if blood then
			table.insert(CORPSES, {blood=blood, modedeath=modedeath, type=type or nil, hx=hx or nil, hy=hy or nil})
		end
	end
	PLAYERS_V[victim]=0
end

function MOD.spawn_bp(x,y,power,team,look,modedeath,mode)
	local imgs={}
	if power<5 then
		power=5
	end
	if mode[1]=="all" then
		mode={"h","a","a","l","l","t","i","b","b"}
		for k,v in pairs(mode) do
		local path=global_path.."/bp/"
		local tpower
			if v=="t" then tpower=3 else tpower=power+math.random(-power/5,power/5) end
			if v=="b" then
				path=path..v..math.random(1,3)..".png"
			elseif v=="i" then
				path=path..v..".png"
			else
				if gamemode==4 then
					if team==2 then
						path=path..team..look..v..".png"
					else
						path=path.."z"..v..".png"
					end
				else
					path=path..team..look..v..".png"
				end
			end
			table.insert(imgs,{image(path,x,y,0),modedeath,tpower,math.random(0,359),x,y,math.random(0,100)})
		end
	else
		for k,v in pairs(mode) do
		local path=global_path.."/bp/"
		local tpower
			if v=="t" then tpower=3 else tpower=power+math.random(-power/5,power/5) end
			if v=="b" then
				path=path..v..math.random(1,3)..".png"
			elseif v=="i" then
				path=path..v..".png"
			else
				if gamemode==4 then
					if team==2 then
						path=path..team..look..v..".png"
					else
						path=path.."z"..v..".png"
					end
				else
					path=path..team..look..v..".png"
				end
			end
			table.insert(imgs,{image(path,x,y,0),modedeath,tpower,math.random(0,359),x,y,math.random(0,100)})
		end
	end
	table.insert(BP,imgs)
end

function MOD.remove_corpse(id)
	for k,v in pairs(CORPSES) do
		if id == k then
			if v.img then
				freeimage(v.img)
			end
			if v.blood then
				freeimage(v.blood)
			end
			CORPSES[id] = nil
		end
	end
end

function MOD.remove_bp(id)
	for k,v in pairs(BP) do
		if id == k then
			for key,images in pairs(v) do
				freeimage(images[1])
			end
			BP[id]=nil
		end
	end
end

-- End functions